import requests
import re
import json
import time
def accessKey():
    # Define your Charles Proxy settings
    proxies = {
        "http": "http://127.0.0.1:8888",
        "https": "http://127.0.0.1:8888",
    }
    headers = {
        "User-Agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.0 Safari/605.1.15",
        "Accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8",
        "Accept-Language": "en-US,en;q=0.5",
        "DNT": "1",
        "Connection": "keep-alive",
        "Referer": "https://duckduckgo.com/"
    }
    token_url = "https://duckduckgo.com/local.js?get_mk_token=1"
    try:
        token_response = requests.get(token_url, headers=headers, proxies=proxies, verify=False)
        token_response.raise_for_status()
        
        bearer_token = token_response.text.strip()
        
        if not bearer_token:
            print("Received empty response from DuckDuckGo token endpoint.")
            return None
    except requests.exceptions.RequestException as e:
        print(f"Error fetching token: {e}")
        if hasattr(e, 'response') and e.response is not None:
            print(f"Server response content: {e.response.text[:200]}...")
        return None
    print(f"Obtained Bearer Token: {bearer_token}")
    mapkit_url = "https://cdn.apple-mapkit.com/ma/bootstrap?apiVersion=2&mkjsVersion=5.79.95&poi=1"
    mapkit_headers = {
        **headers, 
        "Origin": "https://duckduckgo.com",
        "Authorization": f"Bearer {bearer_token}"
    }
    try:
        mapkit_response = requests.get(mapkit_url, headers=mapkit_headers, proxies=proxies, verify=False)
        mapkit_response.raise_for_status()
    except requests.exceptions.RequestException as e:
        print(f"Error fetching Apple MapKit data: {e}")
        return None
    try:
        mapkit_data = mapkit_response.json()
        access_key = mapkit_data.get("accessKey")
        if access_key:
            return access_key
        else:
            print("accessKey not found in the MapKit response.")
            return None
    except json.JSONDecodeError as e:
        print(f"Error decoding JSON from MapKit response: {e}")
        print(f"Response content: {mapkit_response.text[:200]}...")
        return None
if __name__ == "__main__":
    requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)
    access_key = accessKey()
    if access_key:
        print(f"\nMapKit accessKey: {access_key}")
    else:
        print("\nFailed to retrieve the MapKit accessKey.")
